//
// Created by 阳坤 on 2022/3/1.
//

#include "utils/video_similarity.h"

/**
 * 1、判断比对文件的 MD5 是否相等
 *  1.1、如果相等，
 *   1.1.1、判断媒体数据 mate 信息是否一致，如果一致，判断前面 N 关键帧的指纹码
 *  1.2、如果不等
 *   1.2.1、判断媒体数据 mate 信息是否一致, 如果一致，判断前面 N 关键帧的指纹码
 * @param argc
 * @param argv
 * @return
 */
int main(int argc, char *argv[]) {
    const char *filepath = "/Users/devyk/Data/Project/piaoquan/PQMedia/temp/4.mp4";
    long id = video_similarity_detection_init(filepath);
    std::vector<VideoSimilarityModel *> lists;
    int ret = video_similarity_detection_start(id, 1, -1, AUDIO, lists);
    for (int i = 0; i < lists.size(); ++i) {
        auto model = lists[i];
        int len = model->img_len;
        const char *image_hash = model->image_hash;
        for (int i = 0; i < len; ++i) {
            printf("%d ", image_hash[i]);
        }
        printf("\n");
        LOGE("frame-video I-Frame=%d pts=%lld\n", model->pict_type == AV_PICTURE_TYPE_I,
             model->pts);
        if (image_hash)
            free((void *) image_hash);
        delete model;
    }
    lists.clear();
    lists.shrink_to_fit();

    video_similarity_detection_close(id);
    return 0;
}

